Exiv2::CrwImage Class Reference

Class to access raw Canon CRW images. Only Exif metadata and a comment are supported. CRW format does not contain IPTC metadata. More...

`#include <crwimage.hpp>`

Inheritance diagram for Exiv2::CrwImage:
[legend]

## Public Member Functions

Creators
| CrwImage (BasicIo::AutoPtr io, bool create)
| Constructor that can either open an existing CRW image or create a new image from scratch. If a new image is to be created, any existing data is overwritten. Since the constructor can not return a result, callers should check the good() method after object construction to determine success or failure. More...
Manipulators
void | readMetadata ()
| Read all metadata supported by a specific image format from the image. Before this method is called, the image metadata will be cleared. More...
void | writeMetadata ()
| Write metadata back to the image. More...
void | setIptcData (const IptcData &iptcData)
| Not supported. CRW format does not contain IPTC metadata. Calling this function will throw an Error(kerInvalidSettingForImage).
Accessors
std::string | mimeType () const
| Return the MIME type of the image. More...
int | pixelWidth () const
| Return the pixel width of the image.
int | pixelHeight () const
| Return the pixel height of the image.
Public Member Functions inherited from Exiv2::Image
| Image (int imageType, uint16_t supportedMetadata, BasicIo::AutoPtr io)
| Constructor taking the image type, a bitmap of the supported metadata types and an auto-pointer that owns an IO instance. See subclass constructor doc.
virtual | ~Image ()
| Virtual Destructor.
virtual void | printStructure (std::ostream &out, PrintStructureOption option=kpsNone, int depth=0)
| Print out the structure of image file. More...
virtual void | setExifData (const ExifData &exifData)
| Assign new Exif data. The new Exif data is not written to the image until the writeMetadata() method is called. More...
virtual void | clearExifData ()
| Erase any buffered Exif data. Exif data is not removed from the actual image until the writeMetadata() method is called.
virtual void | clearIptcData ()
| Erase any buffered IPTC data. IPTC data is not removed from the actual image until the writeMetadata() method is called.
virtual void | setXmpPacket (const std::string &xmpPacket)
| Assign a raw XMP packet. The new XMP packet is not written to the image until the writeMetadata() method is called. More...
virtual void | clearXmpPacket ()
| Erase the buffered XMP packet. XMP data is not removed from the actual image until the writeMetadata() method is called. More...
virtual void | setXmpData (const XmpData &xmpData)
| Assign new XMP data. The new XMP data is not written to the image until the writeMetadata() method is called. More...
virtual void | clearXmpData ()
| Erase any buffered XMP data. XMP data is not removed from the actual image until the writeMetadata() method is called. More...
virtual void | setComment (const std::string &comment)
| Set the image comment. The new comment is not written to the image until the writeMetadata() method is called. More...
virtual void | clearComment ()
| Erase any buffered comment. Comment is not removed from the actual image until the writeMetadata() method is called.
virtual void | setIccProfile (DataBuf &iccProfile, bool bTestValid=true)
| Set the image iccProfile. The new profile is not written to the image until the writeMetadata() method is called. More...
virtual void | clearIccProfile ()
| Erase iccProfile. the profile is not removed from the actual image until the writeMetadata() method is called.
virtual bool | iccProfileDefined ()
| Erase iccProfile. the profile is not removed from the actual image until the writeMetadata() method is called.
virtual DataBuf * | iccProfile ()
| return iccProfile
virtual void | setMetadata (const Image &image)
| Copy all existing metadata from source Image. The data is copied into internal buffers and is not written to the image until the writeMetadata() method is called. More...
virtual void | clearMetadata ()
| Erase all buffered metadata. Metadata is not removed from the actual image until the writeMetadata() method is called.
virtual ExifData & | exifData ()
| Returns an ExifData instance containing currently buffered Exif data. More...
virtual IptcData & | iptcData ()
| Returns an IptcData instance containing currently buffered IPTC data. More...
virtual XmpData & | xmpData ()
| Returns an XmpData instance containing currently buffered XMP data. More...
virtual std::string & | xmpPacket ()
| Return a modifiable reference to the raw XMP packet.
void | writeXmpFromPacket (bool flag)
| Determine the source when writing XMP. More...
void | setByteOrder (ByteOrder byteOrder)
| Set the byte order to encode the Exif metadata in. More...
void | printTiffStructure (BasicIo &io, std::ostream &out, PrintStructureOption option, int depth, size_t offset=0)
| Print out the structure of image file. More...
void | printIFDStructure (BasicIo &io, std::ostream &out, Exiv2::PrintStructureOption option, uint32_t start, bool bSwap, char c, int depth)
| Print out the structure of a TIFF IFD.
bool | isBigEndianPlatform ()
| is the host platform bigEndian
bool | isLittleEndianPlatform ()
| is the host platform littleEndian
bool | isStringType (uint16_t type)
bool | isShortType (uint16_t type)
bool | isLongType (uint16_t type)
bool | isLongLongType (uint16_t type)
bool | isRationalType (uint16_t type)
bool | is2ByteType (uint16_t type)
bool | is4ByteType (uint16_t type)
bool | is8ByteType (uint16_t type)
bool | isPrintXMP (uint16_t type, Exiv2::PrintStructureOption option)
bool | isPrintICC (uint16_t type, Exiv2::PrintStructureOption option)
uint64_t | byteSwap (uint64_t value, bool bSwap) const
uint32_t | byteSwap (uint32_t value, bool bSwap) const
uint16_t | byteSwap (uint16_t value, bool bSwap) const
uint16_t | byteSwap2 (const DataBuf &buf, size_t offset, bool bSwap) const
uint32_t | byteSwap4 (const DataBuf &buf, size_t offset, bool bSwap) const
uint64_t | byteSwap8 (const DataBuf &buf, size_t offset, bool bSwap) const
ByteOrder | byteOrder () const
| Return the byte order in which the Exif metadata of the image is encoded. Initially, it is not set (invalidByteOrder).
bool | good () const
| Check if the Image instance is valid. Use after object construction. More...
virtual const ExifData & | exifData () const
| Returns an ExifData instance containing currently buffered Exif data. More...
virtual const IptcData & | iptcData () const
| Returns an IptcData instance containing currently buffered IPTC data. More...
virtual const XmpData & | xmpData () const
| Returns an XmpData instance containing currently buffered XMP data. More...
virtual std::string | comment () const
| Return a copy of the image comment. May be an empty string.
virtual const std::string & | xmpPacket () const
| Return the raw XMP packet as a string.
virtual BasicIo & | io () const
| Return a reference to the BasicIo instance being used for Io. More...
AccessMode | checkMode (MetadataId metadataId) const
| Returns the access mode, i.e., the metadata functions, which this image supports for the metadata type metadataId. More...
bool | supportsMetadata (MetadataId metadataId) const
| Check if image supports a particular type of metadata. This method is deprecated. Use checkMode() instead.
bool | writeXmpFromPacket () const
| Return the flag indicating the source when writing XMP metadata.
const NativePreviewList & | nativePreviews () const
| Return list of native previews. This is meant to be used only by the PreviewManager.
void | setTypeSupported (int imageType, uint16_t supportedMetadata)
| set type support for this image format
int | imageType () const
| set type support for this image format

## Additional Inherited Members

Public Types inherited from Exiv2::Image
typedef std::auto_ptr< Image > | AutoPtr
| Image auto_ptr type.
Protected Member Functions inherited from Exiv2::Image
const std::string & | tagName (uint16_t tag)
| Return tag name for given tag id.
const char * | typeName (uint16_t tag) const
| Return tag type for given tag id. More...
Protected Attributes inherited from Exiv2::Image
BasicIo::AutoPtr | io_
| Image data IO pointer.
ExifData | exifData_
| Exif data container.
IptcData | iptcData_
| IPTC data container.
XmpData | xmpData_
| XMP data container.
DataBuf | iccProfile_
| ICC buffer (binary data)
std::string | comment_
| User comment.
std::string | xmpPacket_
| XMP packet.
int | pixelWidth_
| image pixel width
int | pixelHeight_
| image pixel height
NativePreviewList | nativePreviews_
| list of native previews

## Detailed Description

Class to access raw Canon CRW images. Only Exif metadata and a comment are supported. CRW format does not contain IPTC metadata.

## Constructor & Destructor Documentation

## CrwImage()

Exiv2::CrwImage::CrwImage | ( | BasicIo::AutoPtr | io,
|  | bool | create
| ) |  |

Constructor that can either open an existing CRW image or create a new image from scratch. If a new image is to be created, any existing data is overwritten. Since the constructor can not return a result, callers should check the good() method after object construction to determine success or failure.

Parameters

  io | An auto-pointer that owns a BasicIo instance used for reading and writing image metadata. Important: The constructor takes ownership of the passed in BasicIo instance through the auto-pointer. Callers should not continue to use the BasicIo instance after it is passed to this method. Use the Image::io() method to get a temporary reference.
  create | Specifies if an existing image should be read (false) or if a new file should be created (true).

## Member Function Documentation

## mimeType()

std::string Exiv2::CrwImage::mimeType | ( |  | ) | const

virtual

Return the MIME type of the image.

Note
  For each supported image format, the library knows only one MIME type. This may not be the most specific MIME type for that format. In particular, several RAW formats are variants of the TIFF format with the same magic as TIFF itself. Class TiffImage handles most of them and thus they all have MIME type "image/tiff", although a more specific MIME type may exist (e.g., "image/x-nikon-nef").

Implements Exiv2::Image.

## readMetadata()

void Exiv2::CrwImage::readMetadata | ( |  | ) |

virtual

Read all metadata supported by a specific image format from the image. Before this method is called, the image metadata will be cleared.

This method returns success even if no metadata is found in the image. Callers must therefore check the size of individual metadata types before accessing the data.

Exceptions

  Error | if opening or reading of the file fails or the image data is not valid (does not look like data of the specific image type).

Implements Exiv2::Image.

References Exiv2::Image::clearMetadata(), Exiv2::CrwParser::decode(), Exiv2::Image::io(), Exiv2::Image::io_, Exiv2::isCrwType(), Exiv2::DataBuf::pData_, Exiv2::DataBuf::size_, and Exiv2::strError().

## writeMetadata()

void Exiv2::CrwImage::writeMetadata | ( |  | ) |

virtual

Write metadata back to the image.

All existing metadata sections in the image are either created, replaced, or erased. If values for a given metadata type have been assigned, a section for that metadata type will either be created or replaced. If no values have been assigned to a given metadata type, any exists section for that metadata type will be removed from the image.

Exceptions

  Error | if the operation fails

Implements Exiv2::Image.

References Exiv2::DataBuf::alloc(), Exiv2::CrwParser::encode(), Exiv2::Image::io_, Exiv2::isCrwType(), Exiv2::DataBuf::pData_, Exiv2::DataBuf::reset(), and Exiv2::DataBuf::size_.

The documentation for this class was generated from the following files:

- crwimage.hpp
- crwimage.cpp